VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form frmSQLDMO 
   Caption         =   "Database Objects Scripting utility"
   ClientHeight    =   5940
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6420
   LinkTopic       =   "Form1"
   ScaleHeight     =   5940
   ScaleWidth      =   6420
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   4320
      TabIndex        =   4
      Top             =   3240
      Width           =   1455
   End
   Begin VB.ComboBox cboDB 
      Height          =   315
      Left            =   1440
      TabIndex        =   5
      Top             =   4320
      Width           =   2535
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1440
      PasswordChar    =   "*"
      TabIndex        =   3
      Top             =   3960
      Width           =   2535
   End
   Begin VB.TextBox txtLogin 
      Height          =   315
      Left            =   1440
      TabIndex        =   2
      Top             =   3600
      Width           =   2535
   End
   Begin VB.TextBox txtServer 
      Height          =   315
      Left            =   1440
      TabIndex        =   1
      Top             =   3240
      Width           =   2535
   End
   Begin VB.CommandButton cmdTables 
      Caption         =   "Script Tables"
      Height          =   375
      Left            =   1440
      TabIndex        =   6
      Top             =   4800
      Width           =   1455
   End
   Begin VB.CommandButton cmdProcs 
      Caption         =   "Script Procedures"
      Height          =   375
      Left            =   3000
      TabIndex        =   7
      Top             =   4800
      Width           =   1455
   End
   Begin VB.CommandButton cmdViews 
      Caption         =   "Script Views"
      Height          =   375
      Left            =   4560
      TabIndex        =   8
      Top             =   4800
      Width           =   1455
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   4800
      TabIndex        =   9
      Top             =   1560
      Width           =   1455
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   "Select"
      Height          =   375
      Left            =   4800
      TabIndex        =   14
      TabStop         =   0   'False
      Top             =   1080
      Width           =   1455
   End
   Begin VB.DirListBox lstDir 
      Height          =   1665
      Left            =   120
      TabIndex        =   13
      TabStop         =   0   'False
      Top             =   1080
      Width           =   4335
   End
   Begin MSComctlLib.ProgressBar prgObjects 
      Height          =   270
      Left            =   120
      TabIndex        =   11
      Top             =   5280
      Width           =   6255
      _ExtentX        =   11033
      _ExtentY        =   476
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.TextBox txtPath 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   6135
   End
   Begin VB.Label Label6 
      Caption         =   "Database:"
      Height          =   375
      Left            =   120
      TabIndex        =   19
      Top             =   4320
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "Password:"
      Height          =   375
      Left            =   120
      TabIndex        =   18
      Top             =   3960
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Login:"
      Height          =   375
      Left            =   120
      TabIndex        =   17
      Top             =   3600
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Server Name:"
      Height          =   375
      Left            =   120
      TabIndex        =   16
      Top             =   3240
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Enter Database Connection Info:"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   2880
      Width           =   6135
   End
   Begin VB.Label lblObjects 
      Caption         =   "Currently scripting"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   5640
      Width           =   6255
   End
   Begin VB.Label Label1 
      Caption         =   "Select folder to place database scripts to:"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   6375
   End
End
Attribute VB_Name = "frmSQLDMO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub cmdClose_Click()
Unload Me
End Sub

Private Sub cmdConnect_Click()
If Len(Trim(txtServer.Text)) = 0 Then
    MsgBox "Server name cannot be empty.", vbCritical
    txtServer.SetFocus
    Exit Sub
End If
If Len(Trim(txtLogin.Text)) = 0 Then
    MsgBox "Login cannot be empty.", vbCritical
    txtLogin.SetFocus
    Exit Sub
End If

ConnectToServer Trim(txtServer.Text), Trim(txtLogin.Text), Trim(txtPassword.Text)
End Sub

Private Sub cmdProcs_Click()
If ValidateEntry(txtPath.Text, txtServer.Text, txtLogin.Text, cboDB.Text) = True Then
    GenerateProcScripts Trim(Me.txtPath.Text), Trim(txtServer.Text), Trim(txtLogin.Text), Trim(txtPassword.Text), Trim(cboDB.Text)
End If

End Sub

Private Sub cmdSelect_Click()
Me.txtPath.Text = Me.lstDir.Path
End Sub

Private Sub cmdTables_Click()
If ValidateEntry(txtPath.Text, txtServer.Text, txtLogin.Text, cboDB.Text) = True Then
    GenerateTableScripts Trim(Me.txtPath.Text), Trim(txtServer.Text), Trim(txtLogin.Text), Trim(txtPassword.Text), Trim(cboDB.Text)
End If


End Sub

Private Sub cmdViews_Click()
If ValidateEntry(txtPath.Text, txtServer.Text, txtLogin.Text, cboDB.Text) = True Then
    GenerateViewScripts Trim(Me.txtPath.Text), Trim(txtServer.Text), Trim(txtLogin.Text), Trim(txtPassword.Text), Trim(cboDB.Text)
End If

End Sub

Private Sub Form_Load()
Me.txtPath = ""
Me.txtLogin = ""
Me.txtPassword = ""
Me.txtServer = ""
Me.cboDB = ""
Me.prgObjects.Min = 0
Me.prgObjects.Max = 100
Me.prgObjects.Value = 100
Me.lblObjects.Caption = ""
Me.lstDir.Path = "C:\"
Me.prgObjects.Visible = False
End Sub

Private Function GenerateTableScripts(ByVal sDir As String, ByVal sServerName, ByVal sUser As String, ByVal sPassword As String, ByVal sDBName As String) As Boolean
On Error GoTo ErrorHandler
Dim objServer As New SQLDMO.SQLServer
Dim objDB As New SQLDMO.Database
Dim objTable As SQLDMO.Table
Dim sFileName As String
Dim i As Integer

GenerateTableScripts = False
objServer.Connect sServerName, sUser, sPassword
Set objDB = objServer.Databases(sDBName)
If objDB.Tables.Count = 0 Then
    MsgBox "No Tables are found for this database."
    GenerateTableScripts = True
    Exit Function
End If
Me.prgObjects.Max = objDB.Tables.Count
Me.prgObjects.Min = 0
Me.prgObjects.Value = 0
Me.prgObjects.Visible = True

i = 0
For Each objTable In objDB.Tables
    If objTable.SystemObject = False Then
        sFileName = sDir & "\" & objTable.Name & ".sql"
        objTable.Script SQLDMOScript_Drops + SQLDMOScript_Default + SQLDMOScript_DatabasePermissions + SQLDMOScript_DRI_All + SQLDMOScript_DRI_All + SQLDMOScript_Bindings + SQLDMOScript_DRI_AllConstraints + SQLDMOScript_DRI_Checks + SQLDMOScript_DRI_ForeignKeys, sFileName
        i = i + 1
        Me.prgObjects.Value = Me.prgObjects.Value + 1
        Me.lblObjects.Caption = "Currently Scripting " & objTable.Name & " table..."
        DoEvents
    End If
Next
If i = 0 Then
    Me.prgObjects.Value = Me.prgObjects.Max
    Me.lblObjects.Caption = ""
    MsgBox "No non-system tables were found for this database.", vbInformation
    GenerateTableScripts = True
    Set objServer = Nothing
    Set objDB = Nothing
   
   Exit Function
Else
    Me.prgObjects.Value = Me.prgObjects.Max
    Me.lblObjects.Caption = "All Tables were successfully scripted. Scripted tables count:" & CStr(i)
    GenerateTableScripts = True
    Set objServer = Nothing
    Set objDB = Nothing
    
    Exit Function
End If

ErrorHandler:
MsgBox Err.Description, vbCritical
Me.prgObjects.Value = 0
Me.lblObjects.Caption = "Error scripting tables."
Set objServer = Nothing
Set objDB = Nothing
GenerateTableScripts = False
End Function

Private Function GenerateViewScripts(ByVal sDir As String, ByVal sServerName, ByVal sUser As String, ByVal sPassword As String, ByVal sDBName As String) As Boolean
On Error GoTo ErrorHandler
Dim objServer As New SQLDMO.SQLServer
Dim objDB As New SQLDMO.Database
Dim objView As SQLDMO.View
Dim sFileName As String
Dim i As Integer

GenerateViewScripts = False
objServer.Connect sServerName, sUser, sPassword
Set objDB = objServer.Databases(sDBName)
Me.prgObjects.Max = objDB.Views.Count
Me.prgObjects.Min = 0
Me.prgObjects.Value = 0
Me.prgObjects.Visible = True

i = 0
For Each objView In objDB.Views
    If objView.SystemObject = False Then
        sFileName = sDir & "\" & objView.Name & ".sql"
        objView.Script SQLDMOScript_Default + SQLDMOScript_Drops + SQLDMOScript_DatabasePermissions
        i = i + 1
        Me.prgObjects.Value = Me.prgObjects.Value + 1
        Me.lblObjects.Caption = "Currently Scripting " & objView.Name & " view..."
        DoEvents
    End If
Next
If i = 0 Then
    Me.prgObjects.Value = Me.prgObjects.Max
    Me.lblObjects.Caption = ""
    MsgBox "No non-system views were found for this database.", vbInformation
    GenerateViewScripts = True
    Set objServer = Nothing
    Set objDB = Nothing
   
   Exit Function
Else
    Me.prgObjects.Value = Me.prgObjects.Max
    Me.lblObjects.Caption = "All Views were successfully scripted. Scripted views count:" & CStr(i)
    GenerateViewScripts = True
    Set objServer = Nothing
    Set objDB = Nothing
    
    Exit Function
End If

ErrorHandler:
MsgBox Err.Description, vbCritical
Me.prgObjects.Value = 0
Me.lblObjects.Caption = "Error scripting tables."
Set objServer = Nothing
Set objDB = Nothing
GenerateViewScripts = False
End Function

Private Function GenerateProcScripts(ByVal sDir As String, ByVal sServerName, ByVal sUser As String, ByVal sPassword As String, ByVal sDBName As String) As Boolean
On Error GoTo ErrorHandler
Dim objServer As New SQLDMO.SQLServer
Dim objDB As New SQLDMO.Database
Dim objProc As SQLDMO.StoredProcedure
Dim sFileName As String
Dim i As Integer

GenerateProcScripts = False
objServer.Connect sServerName, sUser, sPassword
Set objDB = objServer.Databases(sDBName)
Me.prgObjects.Max = objDB.StoredProcedures.Count
Me.prgObjects.Min = 0
Me.prgObjects.Value = 0
Me.prgObjects.Visible = True

i = 0
For Each objProc In objDB.StoredProcedures
    If objProc.SystemObject = False Then
        sFileName = sDir & "\" & objProc.Name & ".sql"
        objProc.Script SQLDMOScript_Default + SQLDMOScript_Drops + SQLDMOScript_DatabasePermissions, sFileName
        i = i + 1
        Me.prgObjects.Value = Me.prgObjects.Value + 1
        Me.lblObjects.Caption = "Currently Scripting " & objProc.Name & " procedure..."
        DoEvents
    End If
Next
If i = 0 Then
    Me.prgObjects.Value = Me.prgObjects.Max
    Me.lblObjects.Caption = ""
    MsgBox "No non-system procedures were found for this database.", vbInformation
    GenerateProcScripts = True
    Set objServer = Nothing
    Set objDB = Nothing

   Exit Function
Else
    Me.prgObjects.Value = Me.prgObjects.Max
    Me.lblObjects.Caption = "All Stored Procedures were successfully scripted. Scripted procedures count:" & CStr(i)
    Set objServer = Nothing
    Set objDB = Nothing
    
    GenerateProcScripts = True
    Exit Function
End If

ErrorHandler:
MsgBox Err.Description, vbCritical
Me.prgObjects.Value = 0
Me.lblObjects.Caption = "Error scripting procedures."
Set objServer = Nothing
Set objDB = Nothing
GenerateProcScripts = False
End Function


Private Function ValidateEntry(ByVal sPath As String, ByVal sServer As String, ByVal sUser As String, ByVal sDB As String) As Boolean
On Error GoTo ErrorHandler
Dim f As New FileSystemObject
If Len(Trim(sPath)) = 0 Then
    MsgBox "Folder name for scripts cannot be empty.", vbCritical
    txtPath.SetFocus
    ValidateEntry = False
    Exit Function
End If
If f.FolderExists(sPath) = False Then
    If MsgBox("Folder specified does not exist. Do you want to create it?", vbQuestion + vbYesNo) = vbYes Then
        f.CreateFolder sPath
    Else
        txtPath.SetFocus
        ValidateEntry = False
        Exit Function
    End If
End If
If Len(Trim(sServer)) = 0 Then
    MsgBox "Server name cannot be empty.", vbCritical
    txtServer.SetFocus
    ValidateEntry = False
    Exit Function
End If
If Len(Trim(sDB)) = 0 Then
    MsgBox "Database name cannot be empty.", vbCritical
    cboDB.SetFocus
    ValidateEntry = False
    Exit Function
End If
If Len(Trim(sUser)) = 0 Then
    MsgBox "Login cannot be empty.", vbCritical
    txtLogin.SetFocus
    ValidateEntry = False
    Exit Function
End If


    
    
ValidateEntry = True
Set f = Nothing
Exit Function
ErrorHandler:
MsgBox Err.Description, vbCritical
txtPath.SetFocus
Set f = Nothing
ValidateEntry = False
End Function

Private Sub Form_Unload(Cancel As Integer)
Set frmSQLDMO = Nothing
End Sub



Private Function ConnectToServer(ByVal sServerName As String, ByVal sUser As String, ByVal sPassword As String) As Boolean
On Error GoTo ErrorHandler
Dim objServer As New SQLDMO.SQLServer
Dim objDB As New SQLDMO.Database
ConnectToServer = False 'assume failure
objServer.Connect sServerName, sUser, sPassword
Me.cboDB.Clear
For Each objDB In objServer.Databases
Me.cboDB.AddItem objDB.Name
Next
If Me.cboDB.ListCount > 0 Then
    Me.cboDB.ListIndex = 0
End If

Set objServer = Nothing
Set objDB = Nothing
ConnectToServer = True
Exit Function


ErrorHandler:
MsgBox Err.Description, vbCritical
Set objServer = Nothing
Set objDB = Nothing
ConnectToServer = False



End Function
